#include <iostream>
#include <cmath>
#include <algorithm>
#include <map>
#include <vector>
#include <string>
#include <cstring>

typedef long long int ll;
typedef unsigned long long int ull;

ll max(ll n1, ll n2)
{
	return n1 > n2 ? n1 : n2;
}

ll min(ll n1, ll n2)
{
	return n1 < n2 ? n1 : n2;
}

std::vector<ll> Keys;
std::vector<ll> Items;
std::vector<ll> KeysPrior;
ll NumOfK = 0;
ll NumOfI = 0;

void CalcPrior(void)
{
	for (ll i = 0; i < NumOfI; i++)
		KeysPrior[Items[i] - 1] = max(KeysPrior[Items[i] - 1], i + 1);
}

void RecalcPrior(ll ItemNum)
{
	ll i;
	for (i = NumOfI - 1; i >= 0 || Items[i] != ItemNum; i--)
	{
	}
	KeysPrior[Items[ItemNum] - 1] = i + 1;
}

void InsertKey(ll Pos)
{
	ll FirstK = Keys[0];
	memmove(&Keys[0], &Keys[1], Pos - 1);
	Keys[Pos - 1] = FirstK;
}

int main(void)
{
	/* Reading */
	std::cin >> NumOfK >> NumOfI;
	Keys.resize(NumOfK);
	Items.resize(NumOfI);
	KeysPrior.resize(NumOfK);
	for (int i = NumOfI - 1; i >= 0; i--)
		std::cin >> Items[i];
	for (int i = 0; i < NumOfK; i++)
		std::cin >> Keys[i];
	memset(KeysPrior.data(), 0, sizeof(ll) * NumOfK);

	/* Calculate priority */
	CalcPrior();

	/* Run */
	std::string Out;
	Out.reserve(1000000);
	ll NumOfOp = 0;
	while (NumOfI > 0)
	{
		ll CurItem = Items[NumOfI - 1];
	    Items.pop_back();
		NumOfI--;
		//RecalcPrior(CurItem);
		
		while (Keys[0] != CurItem)
		{
			ll Counter;
			bool Fl = false;
			for (Counter = 0; Counter < NumOfK; Counter++)
			{
				if (KeysPrior[Keys[Counter] - 1] == NumOfI + 1)
					Fl = true;
				if (KeysPrior[Keys[Counter] - 1] < Keys[0] && Fl)
					break;
			}
			memset(KeysPrior.data(), 0, sizeof(ll) * NumOfK);
			CalcPrior();
			InsertKey(Counter);
			NumOfOp++;
			Out += std::to_string(Counter);
		}
		if (NumOfI > 0)
			Out += " ";
		else
		{
			if (!Out.empty())
				Out += " ";
			Out += "1";
			NumOfOp++;
		}
	}

	std::cout << NumOfOp << "\n" << Out;

	return 0;
}

/*
const ll SIZE = 10000;

std::vector<ll> Sqr;

ll max(ll n1, ll n2)
{
	return n1 > n2 ? n1 : n2;
}

int main(void)
{
	ll k;

	std::cin >> k;

	Sqr.resize(SIZE);

	for (int i = 0; i < SIZE; i++)
	{
		Sqr[i] = i * i;
	}

	for (auto N : Sqr)
	{
		ll Dist = N - k;

		if (Dist < 0)
			continue;

		for (auto NP : Sqr)
		{
			if (Dist == NP)
			{
				std::cout << sqrt(Dist + k);
				return 0;
			}
			if (NP > Dist)
				break;
		}
	}

	std::cout << "none";

	return 0;
}
*/