#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <cstring>

typedef unsigned long long ull;
typedef long long ll;

ll NumOfSortPar;
ll NumOfK;

struct pare
{
	std::vector<ll> Params;
	ull Num;

	pare(ull Num) : Num(Num)
	{
		Params.resize(NumOfK);
		for (ll i = 0; i < NumOfK; i++)
			std::cin >> Params[i];
	}

	bool operator<(pare &P)
	{
		return P.Params[NumOfSortPar] > Params[NumOfSortPar];
	}

	bool operator>(pare &P)
	{
		return P.Params[NumOfSortPar] < Params[NumOfSortPar];
	}

	bool operator==(pare &P)
	{
		return P.Params[NumOfSortPar] == Params[NumOfSortPar] && Num == P.Num;
	}
};

struct errors
{
	std::vector<pare> More;
	std::vector<pare> Less;
};

std::vector<pare> V;
std::vector<pare> CpyV;
std::vector<bool> MapN;
std::vector<errors> NotCorr;

std::vector<bool> NCNum;

int main(void)
{
	ll n, k;

	std::cin >> n >> k;

	NumOfK = k;

	V.reserve(n);

	ull PareCounter = 1;
	for (ll i = 0; i < n; i++)
		V.push_back(pare(PareCounter++));

	NCNum.resize(n);
	for (ll i = 0; i < n; i++)
		NCNum[i] = true;

	NumOfSortPar = 0;

	std::sort(V.begin(), V.end());
	CpyV = V;
	MapN.resize(n);
	for (ll i = 0; i < n / 2; i++)
		MapN[CpyV[i].Num - 1] = false;
	for (ll i = n / 2; i < n; i++)
		MapN[CpyV[i].Num - 1] = true;

	NotCorr.resize(k);

	for (ll i = 1; i < k; i++)
	{
		ll CountNotAccurate = 0;
		NumOfSortPar = i;
		std::sort(V.begin(), V.end());
		errors NotAccurate;
		for (ll i = 0; i < n / 2; i++)
			if (MapN[V[i].Num - 1] == true)
			{
				NotAccurate.More.push_back(V[i]);
				NCNum[i] = false;
			}
		for (ll i = n / 2; i < n; i++)
			if (MapN[V[i].Num - 1] == false)
			{
				NotAccurate.Less.push_back(V[i]);
				NCNum[i] = false;
			}
		NotCorr[i] = NotAccurate;
	}

	NumOfSortPar = 0;
	for (int i = 1; i < k; i++)
	{
		std::sort(NotCorr[i].More.begin(), NotCorr[i].More.end());
		std::sort(NotCorr[i].Less.begin(), NotCorr[i].Less.end());
	}

	for (int i = 1; i < k - 1; i++)
	{
		if (NotCorr[i].Less.size() != NotCorr[i + 1].Less.size())
		{
			std::cout << "NO";
			return 0;
		}
		for (int j = 0; j < NotCorr[i].Less.size(); j++)
		{
			if (!(NotCorr[i].Less[j] == NotCorr[i + 1].Less[j]))
			{
				std::cout << "NO";
				return 0;
			}
		}
	}

	std::cout << "YES";

	std::vector<ll> CLess;
	std::vector<ll> CMore;

	CLess.reserve(n / 2);
	CMore.reserve(n / 2);

	if (k != 1)
	{
		for (ll i = 0; i < NotCorr[1].Less.size(); i++)
		{
			CLess.push_back(NotCorr[1].Less[i].Num);
			CMore.push_back(NotCorr[1].More[i].Num);
		}
	}
	ll MoreOffset = 0;
	ll LessOffset = 0;
	for (ll i = 0; i + LessOffset < n / 2; i++)
	{
		bool IsOk = true;
		if (NCNum[CpyV[i + LessOffset].Num] == false)
		{
			LessOffset++;
			IsOk = false;
		}
		if (NCNum[CpyV[n - i - 1 + MoreOffset].Num] == false)
		{
			MoreOffset++;
			IsOk = false;
		}
		if (!IsOk)
		{
			continue;
		}
		CLess.push_back(CpyV[i + LessOffset].Num);
		CMore.push_back(CpyV[n - i - 1 + MoreOffset].Num);
	}

	for (ll i = 0; i < n / 2; i++)
	{
		std::cout << "\n" << CLess[i] << " " << CMore[i];
	}

	return 0;
}

//int CalcPL(int k, int n);
//
//int CalcPM(int k, int n)
//{
//	if (k >= n)
//		return k == n;
//
//	ll Res = 0;
//	for (ll i = k + 1; i <= n - k ; i++)
//		Res += CalcPL(i, n - k);
//
//	return Res;
//}
//
//int CalcPL(int k, int n)
//{
//	if (k >= n)
//		return k == n;
//
//	ll Res = 0;
//
//	for (ll i = 1; i < k; i++)
//		Res += CalcPM(i, n - k);
//
//	return Res;
//}
//
//int main(void)
//{
//	ll n, k;
//
//	std::cin >> n >> k;
//
//	if (n == k)
//		std::cout << "1";
//	else
//		std::cout << CalcPM(k, n) + CalcPL(k, n);
//
//	return 0;
//}

//struct Field
//{
//	std::vector<ll> F;
//	ll Num;
//	ll NumOfP;
//
//	void Generate(ll n, std::vector<ll> &Path)
//	{
//		if (n == 0)
//		{
//			for (auto It = Path.begin(); It != Path.end(); It++)
//				F.push_back(*It);
//			return;
//		}
//		for (ll i = 0; i < NumOfP; i++)
//		{
//			Path[Num - n] = i;
//			Generate(n - 1, Path);
//		}
//	}
//
//	Field(ll n, ll p) : Num(n), NumOfP(p)
//	{
//		F.reserve(pow(p, n));
//		std::vector<ll> Path;
//		Path.resize(n);
//		Generate(n, Path);
//	}
//};
//
//ull n;
//std::vector<ll> V;
//std::vector<ll> Pr;
//
//bool check(void)
//{
//	for (ll i = 1; i < n; i++)
//		if (V[i] != i)
//			return false;
//
//	return V[0] == -1;
//}
//
//int main(void)
//{
//	std::cin >> n;
//
//	V.resize(n);
//	Pr.resize(n);
//
//	memset(Pr.data(), 0, Pr.size() * sizeof(ll));
//
//	for (ll i = 0; i < n; i++)
//		std::cin >> V[i];
//
//	if (check())
//	{
//		std::cout << n / 2 + n % 2;
//		return 0;
//	}
//
//	for (ll i = 0; i < n; i++)
//		if (V[i] != -1)
//			Pr[V[i] - 1]++;
//
//	std::vector<ll> CpyV = V;
//	std::vector<ll> CpyPr = Pr;
//
//	while (true)
//	{
//		ll MPr = 0;
//		for (ll i = 1; i < n; i++)
//			if (Pr[MPr] < Pr[i])
//				MPr = i;
//		if (Pr[MPr] < 1)
//			break;
//		if (V[MPr] != -1)
//			Pr[V[MPr] - 1]--;
//		V[MPr] = -1;
//		Pr[MPr] = -1;
//	}
//
//	ll Counter = 0;
//
//	for (ll i = 0; i < n; i++)
//		Counter += (Pr[i] == 0);
//
//	V = CpyV;
//	Pr = CpyPr;
//
//	Field P(5, 20);
//
//	for (ll NumOfP = 0; NumOfP <= n - Counter; NumOfP++)
//	{
//		if (NumOfP > 5)
//		{
//			std::cout << Counter;
//			return 0;
//		}
//		Field P(NumOfP, n);
//		for (auto It = P.F.begin(); It != P.F.end();)
//		{
//			for (ll i = 0; i < NumOfP - 1; i++)
//				if (P.F[i] == P.F[i + 1])
//					continue;
//			for (ll i = 0; i < NumOfP; i++, It++)
//			{
//				if (V[*It] != -1)
//					Pr[V[*It] - 1]--;
//				V[*It] = -1;
//				Pr[*It] = -1;
//			}
//			ll MPr = 0;
//			for (ll i = 1; i < n; i++)
//				if (Pr[MPr] < Pr[i])
//					MPr = i;
//			if (Pr[MPr] < 1)
//			{
//				std::cout << n - NumOfP;
//				return 0;
//			}
//			V = CpyV;
//			Pr = CpyPr;
//		}
//	}
//
//	return 0;
//}
//
//int main(void)
//{
//	ull a, b, c;
//
//	std::cin >> a >> b >> c;
//
//	ull off = c % 2;
//	ull count = 0;
//	ull NumOfCNeg;
//
//	if (off == 0)
//		NumOfCNeg = (a % 2 == 0);
//	else
//		NumOfCNeg = (a % 2 == 1) + b / c - a / c;
//	/*
//	if (c == 2)
//	{
//		std::cout << (b - a) / 2;
//		return 0;
//	}
//
//	if (b <= 100000)
//	{
//		for (ull i = a; i < b;)
//		{
//			if ((i + 2) % c == 0)
//				i++;
//			else
//				i += 2;
//			count++;
//		}
//		std::cout << count;
//		return 0;
//	}*/
//
//	std::cout << (b - a) / 2 + (b - a) % 2 - NumOfCNeg;
//
//	return 0;
//}